﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Web.Mvc;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Mvc;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;

namespace _9728.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            Map map = new Map("map",
               new System.Web.UI.WebControls.Unit(800, System.Web.UI.WebControls.UnitType.Pixel),
               new System.Web.UI.WebControls.Unit(600, System.Web.UI.WebControls.UnitType.Pixel));

            map.MapUnit = GeographyUnit.DecimalDegree;

            //LayerOverlay layerOverlay = new LayerOverlay();
            //ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(Request.MapPath("~/App_Data/states.shp"));
            //shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
            //shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //layerOverlay.Layers.Add(shapeFileLayer);
            //map.CustomOverlays.Add(layerOverlay);

            ApplyStyles(map);

            return View(map);
        }

        public void ApplyStyles(Map map)
        {
            InMemoryFeatureLayer highlightLayer = new InMemoryFeatureLayer();
            map.DynamicOverlay.Layers.Add(highlightLayer);
            highlightLayer.Open();
            highlightLayer.Columns.Add(new FeatureSourceColumn("SUB_REGION"));

            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(Request.MapPath("~/App_Data/states.shp"));
            shapeFileLayer.Open();            

            string SQLstr = "Select * from states";
            //"Select Gut_Number,GovtLand_G From ALL where Village_Na= '" + drpVillage.SelectedItem.Text + "' and (GovtLand_G='Forest' or GovtLand_G='Government')";
            GeoDataTable dtSQL = shapeFileLayer.QueryTools.ExecuteQuery(SQLstr);

            if (dtSQL.Rows.Count > 0)
            {
                int z = 0;
                highlightLayer.InternalFeatures.Clear();
                List<string> featureIds = new List<string>();
                for (int i = 0; i < dtSQL.Rows.Count; i++)
                {
                    string testValue = dtSQL.Rows[i]["RECID"].ToString();
                    bool isIntString = testValue.All(char.IsDigit);
                    if (isIntString == true)
                        featureIds.Add(dtSQL.Rows[i]["RECID"].ToString());
                    else
                    {
                        //featureIds.Add(GetNumberOnly(gutNo).ToString());
                    }
                }
                Collection<Feature> features = shapeFileLayer.QueryTools.GetFeaturesByIds(featureIds, new string[] { "SUB_REGION" });
                //Feature f = new Feature();
                //f.ColumnValues.Add("GovtLand_G", "Forest");
                //feature.ColumnValues.Add("GovtLand_G", "Government");
                foreach (Feature feature in features)
                {
                    //f = feature;
                    highlightLayer.InternalFeatures.Add(feature.Id + z, feature);
                    z++;
                }
            }

            shapeFileLayer.Close();
            ValueStyle valueStyle = new ValueStyle();
            valueStyle.ColumnName = "SUB_REGION";
            valueStyle.ValueItems.Add(new ValueItem("Mid Atl", new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(130, 38, 153, 0)))));
            valueStyle.ValueItems.Add(new ValueItem("Pacific", new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(110, 245, 245, 122)))));
            valueStyle.ValueItems.Add(new ValueItem("E N Cen", new AreaStyle(new GeoSolidBrush(GeoColors.Black))));
            valueStyle.ValueItems.Add(new ValueItem("E S Cen", new AreaStyle(new GeoSolidBrush(GeoColors.Red))));
            valueStyle.ValueItems.Add(new ValueItem("Mtn", new AreaStyle(new GeoSolidBrush(GeoColors.Purple))));
            valueStyle.ValueItems.Add(new ValueItem("N Eng", new AreaStyle(new GeoSolidBrush(GeoColors.Yellow))));
            valueStyle.ValueItems.Add(new ValueItem("S Atl", new AreaStyle(new GeoSolidBrush(GeoColors.Green))));
            valueStyle.ValueItems.Add(new ValueItem("W S Cen", new AreaStyle(new GeoSolidBrush(GeoColors.Pink))));
            valueStyle.ValueItems.Add(new ValueItem("W N Cen", new AreaStyle(new GeoSolidBrush(GeoColors.Blue))));
            highlightLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(valueStyle);
            highlightLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            if (highlightLayer.InternalFeatures.Count > 0)
            {
                highlightLayer.Open();
                map.CurrentExtent = highlightLayer.GetBoundingBox();
                highlightLayer.Close();
            }
        }
    }
}